/* ------------------------------------------------------------------------*/
/*                                                                         */
/*   TEXTVIEW.H                                                            */
/*                                                                         */
/*   Copyright (c) Borland International 1991                              */
/*   All Rights Reserved.                                                  */
/*                                                                         */
/*   defines the classes TTextDevice and TTerminal                         */
/*                                                                         */
/* ------------------------------------------------------------------------*/


#if defined( Uses_TTextDevice ) && !defined( __TTextDevice )
#define __TTextDevice

#include <iostream.h>

class TRect;
class TScrollBar;

class TTextDevice : public TScroller, public streambuf
{

public:

    TTextDevice( const TRect& bounds,
                 TScrollBar *aHScrollBar,
                 TScrollBar *aVScrollBar
               );

    virtual int consumeChars( const char *s, int count ) = 0;
    virtual int overflow( int = EOF );
    virtual int sync();
private:
    char sbuf[256];
};

#endif  // Uses_TTextDevice

#if defined( Uses_TTerminal ) && !defined( __TTerminal )
#define __TTerminal

class TRect;
class TScrollBar;

class TTerminal: public TTextDevice
{

public:

    friend void genRefs();

    TTerminal( const TRect& bounds,
               TScrollBar *aHScrollBar,
               TScrollBar *aVScrollBar,
               size_t aBufSize
             );
    ~TTerminal();

    virtual int consumeChars( const char *s, int count );

    void bufInc( size_t& val );
    Boolean canInsert( size_t amount );
//    short calcWidth(); JS bogus function
    virtual void draw();
    size_t nextLine( size_t pos );
    size_t prevLines( size_t pos, int lines );
    Boolean queEmpty();

protected:

    size_t bufSize;
    char *buffer;
    size_t queFront, queBack;
    void bufDec(size_t& val);
};

#endif  // Uses_TTerminal

#if defined( Uses_otstream ) && !defined( __otstream )
#define __otstream

#include <iostream.h>


class otstream : public ostream
{

public:

    otstream( TTerminal * );

};


#endif


