/*------------------------------------------------------------*/
/* filename -       tdircoll.cpp                              */
/*                                                            */
/* function(s)                                                */
/*                  TDirCollection member functions           */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TDirCollection
#define Uses_TDirEntry
#define Uses_opstream
#define Uses_ipstream
#include <tv.h>

#if defined(__TV4TS__) || defined(__TV4BCC__)
#include <Dir.h>
#include <dos.h>
#endif

#include <stdlib.h>
#ifdef __TV4ICC__
#  include <direct.h>
#endif
#if !defined( __STRING_H )
#include <String.h>
#endif  // __STRING_H

#ifdef __TV4OS2__
#define INCL_DOSFILEMGR
#include <os2.h>
#endif

#ifdef __TV4EMX__
#include <dos.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/emx.h>
#endif

#ifdef __TV4WATCOMDOS__
#  include <dos.h>
#endif

Boolean driveValid( char drive )
{
#if defined(__TV4TS__)
  REGS r;
  r.h.ah = 0x36;
  r.h.dl = drive - '@';
  int86(0x21,&r,&r);
  return ( r.x.ax !=0xFFFF );
#endif
#if defined(__TV4DJ__)
  REGS r;
  r.h.ah = 0x36;
  r.h.dl = drive - '@';
  int86(0x21,&r,&r);
  return Boolean( r.x.ax !=0xFFFF );
#endif
#ifdef __TV4OS2__
#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
#endif
  FSALLOCATE a;
  return Boolean(!DosQueryFSInfo(drive - '@', FSIL_ALLOC, &a, sizeof(a) ) );
#ifdef __TV4EMX__
  } else {
  REGS r;
  r.h.ah = 0x36;
  r.h.dl = drive - '@';
  _int86(0x21,&r,&r);
  return Boolean( r.x.ax !=0xFFFF );
  };
#endif
#endif

#if defined(__TV4WATCOMDOS__)
#if 0
  // !!! This code crashes OS/2.
  // Diagnosis screen comes up...
  // My fault, should be r.h.ah = 0x36
                           ^^^^
  REGS r;
  r.w.ax = 0x36;
  r.h.dl = drive - '@';
  int386(0x21,&r,&r);
  return Boolean( r.w.ax !=0xFFFF );
  return Boolean(drive >= 'A' && drive <= 'G');
#endif
  diskfree_t ds;
  Boolean res = (Boolean) ! _dos_getdiskfree( drive - '@', &ds );
  errno=0;
  return res;
#endif

}


Boolean isDir( const char *str )
{
#if defined(__TV4TS__) || defined(__TV4BCC__) || defined(__TV4DJ__)
    ffblk ff;
    return Boolean( findfirst( str, &ff, FA_DIREC ) == 0 &&
                    (ff.ff_attrib & FA_DIREC) != 0 );
#endif

#if defined(__TV4WATCOMDOS__)
    find_t ff;
    Boolean ret=Boolean( _dos_findfirst( str, _A_SUBDIR, &ff ) == 0 &&
                        (ff.attrib & _A_SUBDIR) != 0 );
//    _dos_findclose( &ff); for OS/2 only
    return ret;
#endif

#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
   HDIR hdir = HDIR_SYSTEM; // No DosFindClose necessary
   ULONG cFilenames = 1;
   FILEFINDBUF3 findbuf;
   APIRET res;
   res = DosFindFirst( str, &hdir, MUST_HAVE_DIRECTORY, &findbuf, sizeof(findbuf), &cFilenames, FIL_STANDARD);

   return Boolean(res==0); // !!! temporary workaround
#endif
#ifdef __TV4EMX__
  struct _find find;
  int res = __findfirst(str,A_DIR,&find);
  return Boolean(res==0 && (find.attr & A_DIR));
#endif
}

Boolean pathValid( const char *path )
{
    char expPath[TV_MAXPATH];
    strcpy( expPath, path );
    fexpand( expPath );
    int len = strlen(expPath);
    if( len <= 3 )
        return driveValid(expPath[0]);

    if( expPath[len-1] == '\\' )
        expPath[len-1] = EOS;

    return isDir( expPath );
}

Boolean validFileName( const char *fileName )
{
#if defined(__TV4DJ__) || defined(__TV4WATCOMDOS__)
    static const char * const illegalChars = ";,=+<>|\"[] \\"; // FAT
#else
    static const char * const illegalChars = "<>|\"\\"; // HPFS
#endif
/*
    char path[_MAX_PATH];
    char dir[_MAX_DIR];
    char name[_MAX_FNAME];
    char ext[_MAX_EXT];
*/
    char path[TV_MAXPATH];
    char dir[TV_MAXPATH];
    char name[TV_MAXPATH];
    char ext[TV_MAXEXT];

    fnsplit( (char*)fileName, path, dir, name, ext );
    strcat( path, dir );
    if( *dir != EOS && !pathValid( path ) )
        return False;
    if( strpbrk( name, illegalChars ) != 0 ||
        strpbrk( ext+1, illegalChars) != 0 ||
        strchr( ext+1, '.' ) != 0
      )
        return False;
    return True;
}

void getCurDir( char *dir )
{
    dir[0] = getdisk() + 'A';
    dir[1] = ':';
    dir[2] = '\\';
    dir[3] = 0;
    getcurdir( 0, dir+3 );
    if( strlen( dir ) > 3 )
        strcat( dir, "\\" );
}

Boolean isWild( const char *f )
{
    return Boolean( strpbrk( f, "?*" ) != 0 );
}

TStreamable *TDirCollection::build()
{
    return new TDirCollection( streamableInit );
}

void TDirCollection::writeItem( void *obj, opstream& os )
{
    TDirEntry *item = (TDirEntry *)obj;
    os.writeString( item->text() );
    os.writeString( item->dir() );
}

void *TDirCollection::readItem( ipstream& is )
{
    const char *txt = is.readString();
    const char *dir = is.readString();
    return new TDirEntry( txt, dir );
}
