/*------------------------------------------------------------*/
/* filename -       tdirlist.cpp                              */
/*                                                            */
/* function(s)                                                */
/*                  TDirListBox member functions              */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TDirListBox
#define Uses_TEvent
#define Uses_TDirCollection
#define Uses_TChDirDialog
#define Uses_TDirEntry
#define Uses_TButton
#define Uses_DirService
#include <tv.h>

#if !defined( __STRING_H )
#include <String.h>
#endif  // __STRING_H

#include <stdlib.h>

#if defined(__TV4OS2__) && !defined(__TV4EMX__)
#  include <direct.h>
#  define INCL_DOSFILEMGR
#  include <os2.h>
#endif

#ifdef __TV4EMX__
// #  include <sys/emx.h>
#  include <sys/types.h>
#  include <dirent.h>
#endif

#if defined(__TV4BCC__) || defined(__TV4TS__)
  #if !defined( __DIR_H )
  #include <Dir.h>
  #endif  // __DIR_H
  #if !defined( __DOS_H )
  #include <Dos.h>
  #endif  // __DOS_H
  #include <direct.h>
#endif

#if defined(__TV4WATCOMDOS__)
#  include <dos.h>
#endif

TDirListBox::TDirListBox( const TRect& bounds, TScrollBar *aScrollBar ) :
    TListBox( bounds, 1, aScrollBar ),
    cur( 0 )
{
    *dir = EOS;
}

TDirListBox::~TDirListBox()
{ 
   if ( list() )
      destroy( list() );
}

void TDirListBox::getText( char *text, short item, short maxChars )
{
	strncpy( text, list()->at(item)->text(), maxChars );
	text[maxChars] = '\0';
}

void TDirListBox::handleEvent( TEvent& event )
{
    if( event.what == evMouseDown && event.mouse.doubleClick )
        {
        event.what = evCommand;
        event.message.command = cmChangeDir;
        putEvent( event );
        clearEvent( event );
        }
    else
        TListBox::handleEvent( event );
}

Boolean TDirListBox::isSelected( short item )
{
    return Boolean( item == cur );
}

void TDirListBox::showDrives( TDirCollection *dirs )
{
    Boolean isFirst = True;
    char oldc[5];
    strcpy( oldc, "0:\\" );
    for( char c = 'A'; c <= 'Z'; c++ )
        {
        if( c < 'C' || driveValid( c ) )
            {
            if( oldc[0] != '0' )
                {
                char s[ 16 ];
                if( isFirst )
                    {
                    strcpy( s, firstDir );
                    s[ strlen(firstDir) ] = oldc[0];
                    s[ strlen(firstDir)+1 ] = EOS;
                    isFirst = False;
                    }
                else
                    {
                    strcpy( s, middleDir );
                    s[ strlen(middleDir) ] = oldc[0];
                    s[ strlen(middleDir)+1 ] = EOS;
                    }
                dirs->insert( new TDirEntry( s, oldc ) );
                }
            if( c == getdisk() + 'A' )
                cur = dirs->getCount();
            oldc[0] = c;
            }
        }
    if( oldc[0] != '0' )
        {
        char s[ 16 ];
        strcpy( s, lastDir );
        s[ strlen(lastDir) ] = oldc[0];
        s[ strlen(lastDir)+1 ] = EOS;
        dirs->insert( new TDirEntry( s, oldc ) );
        }
}

void TDirListBox::showDirs( TDirCollection *dirs )
{
    DirService server;
    TSearchRec tmpSearchRec;
    int res;
    const indentSize = 2;
    int indent = indentSize;
#if 0
    char buf[MAXPATH+16];
    memset( buf, ' ', sizeof( buf ) );
    char *name = buf + sizeof(buf) - (MAXFILE+MAXEXT);
#endif
    char buf[TV_MAXPATH*2];
    memset( buf, ' ', sizeof( buf ) );
    char *name = buf + TV_MAXPATH;

    char *org = name - strlen(pathDir);
    strcpy( org, pathDir );

    char *curDir = dir;
    char *end = dir + 3;
    char hold = *end;
    *end = EOS;         // mark end of drive name
    strcpy( name, curDir );
    dirs->insert( new TDirEntry( org, name ) );

    *end = hold;        // restore full path
    curDir = end;
    while( (end = strchr( curDir, '\\' )) != 0 )
        {
        *end = EOS;
        strncpy( name, curDir, size_t(end-curDir) );
        name[size_t(end-curDir)] = EOS;
        dirs->insert( new TDirEntry( org - indent, dir ) );
        *end = '\\';
        curDir = end+1;
        indent += indentSize;
        }

    cur = dirs->getCount() - 1;

    end = strrchr( dir, '\\' );
    char path[TV_MAXPATH];
    strncpy( path, dir, size_t(end-dir+1) );
    end = path + unsigned(end-dir)+1;
    strcpy( end, OS_WILDCARDS );

    Boolean isFirst = True;

#if 1
    res = server.findfirst( path, FILE_DIRECTORY, tmpSearchRec );
    while( res == 0 )
        {
        if( (tmpSearchRec.attr & FILE_DIRECTORY) != 0 && tmpSearchRec.name[0] != '.' )
            {
            if( isFirst )
                {
                memcpy( org, firstDir, strlen(firstDir)+1 );
                isFirst = False;
                }
            else
                memcpy( org, middleDir, strlen(middleDir)+1 );
              strcpy( name, tmpSearchRec.name );
              strcpy( end, tmpSearchRec.name );
            dirs->insert( new TDirEntry( org - indent, path ) );
            }
          res = server.findnext( tmpSearchRec );
        }
#endif

#if 0
#if defined (__TV4TS__) || defined (__TV4BCC__) || defined (__TV4DJ__)
    ffblk ff;
    int res = findfirst( path, &ff, FA_DIREC );
#endif
#if defined(__TV4WATCOMDOS__)
    find_t ff;
    int res = _dos_findfirst( path, _A_SUBDIR, &ff);
#endif
#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
   HDIR hdir = HDIR_CREATE; // new handle, must be closed
   ULONG cFilenames = 1;
   FILEFINDBUF3 findbuf;
   APIRET res;
   res = DosFindFirst(path, &hdir, FILE_DIRECTORY, &findbuf, sizeof(findbuf), &cFilenames, FIL_STANDARD);
#endif
#ifdef __TV4EMX__
  struct _find find;
  int res = __findfirst(path, A_DIR, &find );
#endif

    while( res == 0 )
        {
#if defined (__TV4TS__) || defined (__TV4BCC__) || defined (__TV4DJ__)
        if( (ff.ff_attrib & FA_DIREC) != 0 && ff.ff_name[0] != '.' )
#endif
#if defined(__TV4WATCOMDOS__)
        if ( (ff.attrib & _A_SUBDIR) != 0 && ff.name[0] != '.' )
#endif
#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
        if( (findbuf.attrFile & FILE_DIRECTORY) != 0 && findbuf.achName[0] != '.' )
#endif
#ifdef __TV4EMX__
        if( (find.attr & A_DIR) != 0 && find.name[0] != '.' )
#endif
            {
            if( isFirst )
                {
                memcpy( org, firstDir, strlen(firstDir)+1 );
                isFirst = False;
                }
            else
                memcpy( org, middleDir, strlen(middleDir)+1 );
#if defined (__TV4TS__) || defined (__TV4BCC__) || defined (__TV4DJ__)
              strcpy( name, ff.ff_name );
              strcpy( end, ff.ff_name );
#endif
#if defined(__TV4WATCOMDOS__)
              strcpy( name, ff.name );
              strcpy( end, ff.name );
#endif
#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
	      strcpy( name, findbuf.achName );
	      strcpy( end, findbuf.achName );
#endif
#ifdef __TV4EMX__
	      strcpy( name, find.name );
	      strcpy( end, find.name );
#endif
            dirs->insert( new TDirEntry( org - indent, path ) );
            }
#if defined (__TV4TS__) || defined (__TV4BCC__) || defined (__TV4DJ__)
          res = findnext( &ff );
#endif
#if defined(__TV4WATCOMDOS__)
          res = _dos_findnext( &ff );
#endif
#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
          res = DosFindNext( hdir, &findbuf, sizeof(findbuf), &cFilenames);
#endif
#ifdef __TV4EMX__
          res = __findnext( &find );
#endif
        }
#if defined(__TV4ICC__) || defined(__TV4WATCOMOS2__)
    DosFindClose( hdir );
#endif
#ifdef __TV4EMX__
#endif
#endif // #if 0

    char *p = dirs->at(dirs->getCount()-1)->text();
    char *i = strchr( p, graphics[0] );
    if( i == 0 )
        {
        i = strchr( p, graphics[1] );
        if( i != 0 )
            *i = graphics[0];
        }
    else
        {
        *(i+1) = graphics[2];
        *(i+2) = graphics[2];
        }
}

void TDirListBox::newDirectory( const char *str )
{
    strcpy( dir, str );
    TDirCollection *dirs = new TDirCollection( 5, 5 );
    dirs->insert( new TDirEntry( drives, drives ) );
    if( strcmp( dir, drives ) == 0 )
        showDrives( dirs );
    else
        showDirs( dirs );
    newList( dirs );
    focusItem( cur );
}

void TDirListBox::setState( ushort nState, Boolean enable )
{
    TListBox::setState( nState, enable );
    if( (nState & sfFocused) && ((TChDirDialog *)owner)->chDirButton )
        ((TChDirDialog *)owner)->chDirButton->makeDefault( enable );
}

TStreamable *TDirListBox::build()
{
    return new TDirListBox( streamableInit );
}


