/*------------------------------------------------------------*/
/* filename -       tevent.cpp                                */
/*                                                            */
/* function(s)                                                */
/*                  TEvent member functions                   */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TEventQueue
#define Uses_TEvent
#define Uses_TScreen
#define Uses_TKeys
#define Uses_TOS2Handles
#include <tv.h>

#if (defined(__TV4TS__) || defined(__TV4EMX__))
#if !defined( __DOS_H )
#include <dos.h>
#endif  // __DOS_H
#endif

#ifdef __TV4DJ__
#  include <go32.h>
#  include <sys/farptr.h>
#endif

#include <stdlib.h>
#include <conio.h>

#include <iostream.h>
// !!! for debugging

volatile TEventWithSemaphore TEventQueue::eventQueue[ eventQSize ] = { {0} };
volatile int TEventQueue::eventQHead = 0;
volatile int TEventQueue::eventQTail = 0;
Boolean TEventQueue::mouseIntFlag = False;

#ifdef __TV4OS2__
TEvent TEventQueue::keyboardEvent;
unsigned char TEventQueue::shiftState;
#endif

#if defined(__TV4WATCOMDOS__) || defined(__TV4DJ__)
MouseEventType tempMouse;
unsigned mouseIntMax;
#endif

// ushort TEventQueue::eventCount = 0;
Boolean TEventQueue::mouseEvents = False;
Boolean TEventQueue::mouseReverse = False;
unsigned long TEventQueue::doubleDelay = 8;
unsigned long TEventQueue::repeatDelay = 8;
unsigned long TEventQueue::autoTicks = 0;
unsigned long TEventQueue::autoDelay = 0;

MouseEventType TEventQueue::lastMouse;
volatile MouseEventType TEventQueue::curMouse;
volatile long TEventQueue::curMouseSemaphore;
MouseEventType TEventQueue::downMouse;
unsigned long TEventQueue::downTicks = 0;

TEventQueue::TEventQueue()
{
//    resume();
}

void TEventQueue::resume()
{
//    cerr << "TEventQueue::resume\n";
    if( mouse.present() == False )
        mouse.resume();
    if( mouse.present() == False )
        return;
    mouse.getEvent( lastMouse );
    ((MouseEventType&) curMouse) = lastMouse; // Watcom bug workaround
#if defined (__TV4WATCOMDOS__)
    mouse.registerHandler( 0xFFFF, globalMouseInt );
#endif
#if defined (__TV4TS__) || defined (__TV4DJ__)
    mouse.registerHandler( 0xFFFF, mouseInt );
#endif
    mouseEvents = True;
    mouse.show();
    cout << "TScreen: " << (int) TScreen::screenWidth << " " << (int) TScreen::screenHeight << endl;
    TMouse::setRange( TScreen::screenWidth-1, TScreen::screenHeight-1 );
//    DosResumeThread( TOS2Handles::mouseThreadID );
}

void TEventQueue::suspend()
{
//    cerr << "TEventQueue::suspend\n";
//    DosSuspendThread( TOS2Handles::mouseThreadID );
    mouse.suspend();
}

TEventQueue::~TEventQueue()
{
//    suspend();
}

void TEventQueue::getMouseEvent( TEvent& ev )
{
//    (*((unsigned char*) 0x0B8006)) ++; // debugging
    if( mouseEvents == True )
        {

        getMouseState( ev );

        if( ev.mouse.buttons == 0 && lastMouse.buttons != 0 )
            {
            ev.what = evMouseUp;
            lastMouse = ev.mouse;
            return;
            }

        if( ev.mouse.buttons != 0 && lastMouse.buttons == 0 )
            {
            if( ev.mouse.buttons == downMouse.buttons &&
                ev.mouse.where == downMouse.where &&
                ev.time - downTicks <= doubleDelay )
                    ev.mouse.doubleClick = True;

            downMouse = ev.mouse;
            autoTicks = downTicks = ev.time;
            autoDelay = repeatDelay;
            ev.what = evMouseDown;
            lastMouse = ev.mouse;
            return;
            }

        ev.mouse.buttons = lastMouse.buttons;

        if( ev.mouse.where != lastMouse.where )
            {
            ev.what = evMouseMove;
            lastMouse = ev.mouse;
            return;
            }

        if( ev.mouse.buttons != 0 && ev.time - autoTicks > autoDelay )
            {
            autoTicks = ev.time;
            autoDelay = 1;
            ev.what = evMouseAuto;
            lastMouse = ev.mouse;
            return;
            }
        }

//    cout << "N";
    ev.what = evNothing;
}

/*
  The Ringbuffer for the mouse events has been restuctured.
  Every Element now has a semaphore. This way, the interrupts
  do not need to be disabled! Please notice, that under DOS
  the mouse interrupt may interrupt the main program, but
  not the other way around! Before the main program reads
  the curmouse struct, it sets the curMouseSemaphore to 1.
  If the user now moves the mouse, curmouse will not be
  overwritten. Otherwise the main program could read the
  first half of the curmouse struct, then the interrupt
  overwrites the struct and after that the main program reads
  the second half of the curmouse.

  Jrn Sierwald
*/

void TEventQueue::getMouseState( TEvent & ev )
{
#if defined(__TV4OS2__) && !defined(__TV4EMX__)
    assert(! DosRequestMutexSem(TOS2Handles::hmtxMouse1,SEM_INDEFINITE_WAIT) );

    if (eventQueue[eventQHead].semaphore) {
      ev=*((TEvent*) &eventQueue[eventQHead].event); // WATCOM bug workaround
//      cout << "G1" << ev.time << endl;
      eventQueue[eventQHead].semaphore=0;
      eventQHead=(eventQHead+1) % eventQSize;
    } else {
      ev.what = evNothing;
      ev.time = getTicks();
//      cout << "G2" << ev.time << endl;
      ev.mouse = (*(MouseEventType*) &curMouse);
    }

    if (!eventQueue[eventQHead].semaphore) {
      ULONG dummy;
      assert(! DosResetEventSem( TOS2Handles::hevMouse1, &dummy ) );
    };
    assert(! DosReleaseMutexSem(TOS2Handles::hmtxMouse1) );
#else
  #if defined(__TV4EMX__)
    EMX_SWITCH_1
    assert(! DosRequestMutexSem(TOS2Handles::hmtxMouse1,SEM_INDEFINITE_WAIT) );

    if (eventQueue[eventQHead].semaphore) {
      ev=eventQueue[eventQHead].event;
      eventQueue[eventQHead].semaphore=0;
      eventQHead=(eventQHead+1) % eventQSize;
    } else {
      ev.what = evNothing;
      ev.time = getTicks();
      ev.mouse = curMouse;
    }

    if (!eventQueue[eventQHead].semaphore) {
      ULONG dummy;
      assert(! DosResetEventSem( TOS2Handles::hevMouse1, &dummy ) );
    };
    assert(! DosReleaseMutexSem(TOS2Handles::hmtxMouse1) );
    EMX_SWITCH_2
    EMX_SWITCH_3
    if (mouse.present()) {
      if (EMXPtr->eventQueue[EMXPtr->eventQHead].semaphore) {
        ev.what = evNothing;
        ev.time = EMXPtr->eventQueue[EMXPtr->eventQHead].time;
        ev.mouse.buttons = EMXPtr->eventQueue[EMXPtr->eventQHead].mouse.buttons;
        ev.mouse.where.x = EMXPtr->eventQueue[EMXPtr->eventQHead].mouse.x;
        ev.mouse.where.y = EMXPtr->eventQueue[EMXPtr->eventQHead].mouse.y;
        ev.mouse.doubleClick = False;
        EMXPtr->eventQueue[EMXPtr->eventQHead].semaphore=0;
        EMXPtr->eventQHead=(EMXPtr->eventQHead+1) % EMXQueueSize;
//        cout << "Q" << flush;
      } else {
        ev.what = evNothing;
        ev.time = getTicks();
        EMXPtr->curMouseSemaphore=1;
        ev.mouse.buttons = EMXPtr->curMouse.buttons;
        ev.mouse.where.x = EMXPtr->curMouse.x;
        ev.mouse.where.y = EMXPtr->curMouse.y;
        ev.mouse.doubleClick = False;
        EMXPtr->curMouseSemaphore=0;
      };
    } else {
      ev.what = evNothing;
      ev.time = getTicks();
      ev.mouse.buttons = 0;
      ev.mouse.where.x = 0;
      ev.mouse.where.y = 0;
      ev.mouse.doubleClick = False;
    };
    EMX_SWITCH_2
  #endif
  #if defined( __TV4TS__) || defined(__TV4WATCOMDOS__) || defined( __TV4DJ__ )
    if (eventQueue[eventQHead].semaphore) {
      ev=*((TEvent*) &eventQueue[eventQHead].event); // Watcom bug workaround
//      cout << "G1" << ev.time << endl;
      eventQueue[eventQHead].semaphore=0;
      eventQHead=(eventQHead+1) % eventQSize;
    } else {
      ev.what = evNothing;
      ev.time = getTicks();
//      cout << "G2" << ev.time << endl;
      curMouseSemaphore=1;
      ev.mouse = (*(MouseEventType*) &curMouse);  // Watcom bug workaround
      curMouseSemaphore=0;
    }

  #endif
#endif

    if( mouseReverse != False && ev.mouse.buttons != 0 && ev.mouse.buttons != 3 )
        ev.mouse.buttons ^= 3;
}


#if defined (__TV4WATCOMDOS__) 

// Thanks to Watcom for a truly helpful sample program. (not)
// Is it just me, or do the really complicated things never
// work as described in the docs?
// Two Watcom bugs here:
// #pragma aux doesn't accept C++ functions.
// The es register is not loaded.
// I'll change the code as soon as someone tells me how.
// Nichts ist dauerhafter als ein gutes Provisorium.

void ds2es(); // Obscure hack.
#pragma aux ds2es = \
  "push ds" \
  "pop  es" ;

#pragma off (check_stack)
void _loadds far globalMouseInt( int max, int mbx, int mcx, int mdx)
{
#pragma aux globalMouseInt parm [EAX] [EBX] [ECX] [EDX]
  ds2es();
  TEventQueue::mouseInt(max,mbx,mcx,mdx);
};

void TEventQueue::mouseInt( int max, int mbx, int mcx, int mdx)
{
//    (*((unsigned char*) 0x0B8000)) ++; // debugging
//    return;
    mouseIntMax = max & 0xFFFF;
    tempMouse.buttons = mbx & 0xFF;
    tempMouse.doubleClick = False;
    tempMouse.where.x = (mcx & 0xFFFF) >> 3;
    tempMouse.where.y = (mdx & 0xFFFF) >> 3;

    if( !eventQueue[eventQTail].semaphore && (mouseIntMax & 0x1e) != 0 )
        {
        eventQueue[eventQTail].event.what = evNothing;
        eventQueue[eventQTail].event.time = *((unsigned long*) 0x046C); // DOS Timer
        ((MouseEventType&) eventQueue[eventQTail].event.mouse) = tempMouse; // curMouse;
        eventQueue[eventQTail].semaphore = 1;
        eventQTail=(eventQTail+1) % eventQSize;
        }
    if (!curMouseSemaphore)
      ((MouseEventType&) curMouse) = tempMouse;
    mouseIntFlag = True;
};

#pragma on (check_stack)

#else
#  if defined(__TV4DJ__)
void TEventQueue::mouseInt()
{

    mouseIntMax = mouseIntRegs.x.ax;

    tempMouse.buttons = mouseIntRegs.h.bl;
    tempMouse.doubleClick = False;
    tempMouse.where.x = mouseIntRegs.x.cx >> 3;
    tempMouse.where.y = mouseIntRegs.x.dx >> 3;

    if( !eventQueue[eventQTail].semaphore && (mouseIntMax & 0x1e) != 0 )
        {
        eventQueue[eventQTail].event.what = evNothing;
        eventQueue[eventQTail].event.time = _farpeekl(_dos_ds, 0x046C);
        eventQueue[eventQTail].event.mouse = tempMouse; // curMouse;
        eventQueue[eventQTail].semaphore = 1;
        eventQTail=(eventQTail+1) % eventQSize;
        }
    if (!curMouseSemaphore)
      curMouse = tempMouse;
    mouseIntFlag = True;
};


#  else
void TEventQueue::mouseInt()
{
  // no mouse
};
#  endif
#endif

/* This is the original Borland C++ 3.0 mouse handler
#pragma saveregs
void huge TEventQueue::mouseInt()
{
    unsigned flag = _AX;
    MouseEventType tempMouse;

    tempMouse.buttons = _BL;
    tempMouse.doubleClick = False;
    tempMouse.where.x = _CX >> 3;
    tempMouse.where.y = _DX >> 3;

    if( (flag & 0x1e) != 0 && eventCount < eventQSize )
        {
        eventQTail->what = *Ticks;
        eventQTail->mouse = curMouse;
        if( ++eventQTail >= eventQueue + eventQSize )
            eventQTail = eventQueue;
        eventCount++;
        }

    curMouse = tempMouse;
    mouseIntFlag = True;
}
*/

#ifdef __TV4OS2__

// These variables are used to reduce the CPU time used by the
// two threads if they don't receive any input from the user for some time.
volatile int mousePollingDelay = 0;
volatile int keyboardPollingDelay = 0;

#define jsSuspendThread if (TOS2Handles::shutDownFlag) TOS2Handles::deadEnd();

void TEventQueue::mouseThread(void* arg) {
    assert(! DosWaitEventSem(TOS2Handles::hevMouse2, SEM_INDEFINITE_WAIT) ); 
    ULONG dummy;
    MouseEventType tempMouse;
    MOUEVENTINFO *info = &TOS2Handles::tiled->mouseInfo;

    while (1) {
#if 0 // This the blocking version. it doesn't work
      jsSuspendThread
      USHORT type = 1; // non-blocking read
      MouReadEventQue(info, &type, TOS2Handles::tiled->mouseHandle);
#endif
#if 1 // polling version.
    do {
      jsSuspendThread
      USHORT type = 0; // non-blocking read
//    cerr << "W" << flush;
      MouReadEventQue(info, &type, TOS2Handles::tiled->mouseHandle);
//    cerr << "M" << type << flush ;
//    cerr << info->fs << endl;
      if (info->time==0) {
        if (curMouse.buttons) {
          mousePollingDelay=0;
          APIRET rc = DosPostEventSem(TOS2Handles::hevMouse1);
          assert( rc==0 || rc==ERROR_ALREADY_POSTED );
        };
//        cerr << "Mp " << flush;
        DosSleep(mousePollingDelay);
        if (mousePollingDelay < 500) mousePollingDelay += 5;
      } else {
//        cerr << "M " << flush ;
        mousePollingDelay=0;
      };
    } while (info->time==0);
#endif
    tempMouse.buttons = ((info->fs & 06)  != 0) +
                 (((info->fs & 030) != 0) << 1)+
                 (((info->fs & 0140) != 0) << 2);
    tempMouse.where.x = info->col;
    tempMouse.where.y = info->row;
    tempMouse.doubleClick = False;

    jsSuspendThread
    DosRequestMutexSem(TOS2Handles::hmtxMouse1,SEM_INDEFINITE_WAIT);

    if( !eventQueue[eventQTail].semaphore && (tempMouse.buttons!=curMouse.buttons) )
        {
        eventQueue[eventQTail].event.what = evNothing;
//        cout << "M" << info->time/52 << endl;
        eventQueue[eventQTail].event.time = info->time/52;
        ((MouseEventType&)eventQueue[eventQTail].event.mouse) = tempMouse; // WATCOM bug
        eventQueue[eventQTail].semaphore = 1;
        eventQTail=(eventQTail+1) % eventQSize;
        }
    ((MouseEventType&)curMouse) = tempMouse;
#if 0
    if( (tempMouse.buttons!=curMouse.buttons) && eventCount < eventQSize )
        {
        eventQTail->what = evNothing;
        eventQTail->time = info->time/52; //*Ticks;
        eventQTail->mouse = tempMouse; // curMouse;
        if( ++eventQTail >= eventQueue + eventQSize )
            eventQTail = eventQueue;
        eventCount++;
        }

    curMouse = tempMouse;
#endif

    APIRET rc = DosPostEventSem(TOS2Handles::hevMouse1);
    assert( rc==0 || rc==ERROR_ALREADY_POSTED );
    assert(! DosReleaseMutexSem(TOS2Handles::hmtxMouse1));

//    DosWaitEventSem(TOS2Handles::hevMouse2,SEM_INDEFINITE_WAIT);
//    DosResetEventSem(TOS2Handles::hevMouse2,&dummy);
 
    };

};

void TEventQueue::keyboardThread( void * arg ) {
  KBDKEYINFO *info = &TOS2Handles::tiled->keyboardInfo;
  while (1) {
#if 0
  jsSuspendThread
  USHORT errCode = KbdCharIn( info, IO_WAIT, 0 );
  jsSuspendThread
  cerr << "Key ";
#endif
  jsSuspendThread
  USHORT errCode = KbdCharIn( info, IO_NOWAIT, 0 );
  jsSuspendThread
  if (info->fbStatus) {
    int a=762; // Debugger Breakpoint
  } /* endif */
  if (errCode || (info->fbStatus & 0xC0)!=0x40 || info->fbStatus & 1) { // no char
    keyboardEvent.what = evNothing;
//    cerr << "Kp " << flush;
    DosSleep(keyboardPollingDelay);
    if (keyboardPollingDelay < 500) keyboardPollingDelay += 5;
  } else {
//    cerr << "K " << flush;
    keyboardEvent.what = evKeyDown;

    if ((info->fbStatus & 2) && (info->chChar==0xE0)) info->chChar=0; // OS/2 cursor keys.
    keyboardEvent.keyDown.charScan.charCode=info->chChar;
    keyboardEvent.keyDown.charScan.scanCode=info->chScan;
    shiftState = info->fsState & 0xFF;

    jsSuspendThread
    assert(! DosPostEventSem(TOS2Handles::hevKeyboard1) );
    jsSuspendThread
    assert(! DosWaitEventSem(TOS2Handles::hevKeyboard2, SEM_INDEFINITE_WAIT) );
    ULONG dummy;
    assert(! DosResetEventSem(TOS2Handles::hevKeyboard2, &dummy) );
    jsSuspendThread
    keyboardPollingDelay=0;
    };
  };
};
#endif // TV4OS2

// Some Scancode conversion.. in OS/2 ShiftIns/ShiftDel only
// I didn't understand the CtrlDel/Ins Conversion. Maybe this is
// XT-Keyboard only. js

const unsigned char scSpaceKey          = 0x39;
const unsigned char scInsKey            = 0x52;
const unsigned char scDelKey            = 0x53;
const unsigned char scGreyEnterKey      = 0xE0;

static unsigned char translateTable1[] =
  { scSpaceKey,
    scInsKey, scDelKey,
    scInsKey, scDelKey  };

static unsigned char translateTable2[] =
  { kbAltShift,
    kbCtrlShift, kbCtrlShift,
    kbLeftShift+kbRightShift, kbLeftShift+kbRightShift };

static unsigned short translateTable3[]=
  { kbAltSpace,
    kbCtrlIns,  kbCtrlDel,
    kbShiftIns, kbShiftDel };

const unsigned translateTableLength = 5;


void TEvent::getKeyEvent()
{
  unsigned char shiftState = 0;
#ifdef __TV4OS2__
  EMX_SWITCH_1
  ULONG dummy;
  assert(! DosResetEventSem(TOS2Handles::hevKeyboard1, &dummy) );
  *this = TEventQueue::keyboardEvent;
  shiftState = TEventQueue::shiftState;
//  cerr << "Key: " << keyDown.keyCode << endl;
  assert(! DosPostEventSem(TOS2Handles::hevKeyboard2) );
  EMX_SWITCH_2
#endif

#ifdef __TV4EMX__

  EMX_SWITCH_3
//  cout << "%" << flush;
  REGS r;
  r.h.ah=1;
  _int86(0x16,&r,&r);
  if ((r.x.flags & 0x0040)) {
    what = evNothing;
  } else {
    what = evKeyDown;
    r.h.ah=0;
    _int86(0x16,&r,&r);
    keyDown.keyCode = r.x.ax;
    shiftState = getShiftState();
//    cout << "Key: " << keyDown.keyCode << endl;
  };
  EMX_SWITCH_2

#endif

#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.ah=1;
  int86(0x16,&r,&r);
  if ((r.x.flags & 0x0040)) {
    what = evNothing;
  } else {
    what = evKeyDown;
    r.h.ah=0;
    int86(0x16,&r,&r);
    keyDown.keyCode = r.x.ax;
    shiftState = getShiftState();
  };
#endif

#ifdef __TV4WATCOMDOS__
  REGS r;
  REGPACK rp;
  memset( &rp, 0, sizeof(rp));
  rp.h.ah=1;
  intr( 0x16,&rp );
//  int386(0x16,&r,&r); Watcom REGS has no flags...
  if ((rp.x.flags & 0x0040)) {
    what = evNothing;
  } else {
    what = evKeyDown;
    r.h.ah=0;
    int386(0x16,&r,&r);
    keyDown.keyCode = r.w.ax;
    shiftState = getShiftState();
  };
#endif

/*    if (keyDown.charScan.scanCode == 0x53)
      cerr << "@@" << (int) keyDown.charScan.scanCode << "@" << (int)shiftState << flush;
        DosSleep(1000);
*/
    for (int i=0; i<translateTableLength; i++) {
      if ((translateTable1[i]==keyDown.charScan.scanCode) &&
          (translateTable2[i] & shiftState))
      {
        keyDown.keyCode = translateTable3[i];
        break;
      };
    };
    if ( keyDown.charScan.scanCode == scGreyEnterKey )
      keyDown.keyCode = kbEnter; // by Ilfak

  return;

};

