/*------------------------------------------------------------*/
/* filename -       tfilecol.cpp                              */
/*                                                            */
/* function(s)                                                */
/*                  TFileCollection member functions          */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/


#define Uses_TFileCollection
#define Uses_TSearchRec
#include <tv.h>

#if defined(__TV4BCC__) || defined(__TV4TS__)
#if !defined( __DOS_H )
#include <DOS.h>
#endif  // __DOS_H
#endif

#if defined(__TV4WATCOMDOS__)
#  include <dos.h>
#  define FILE_DIRECTORY _A_SUBDIR
#endif

#if !defined( __STRING_H )
#include <String.h>
#endif  // __STRING_H

inline const char *getName( void *k )
{
    return ((TSearchRec *)k)->name;
}

inline int attr( void *k )
{
    return ((TSearchRec *)k)->attr;
}

int TFileCollection::compare(void *key1, void *key2)
{
#ifdef __TV4ICC__
    if( strcmpi( getName( key1 ), getName( key2 ) ) == 0 )
#else
    if( stricmp( getName( key1 ), getName( key2 ) ) == 0 )
#endif
        return 0;

    if( strcmp( getName( key1 ), ".." ) == 0 )
        return 1;
    if( strcmp( getName( key2 ), ".." ) == 0 )
        return -1;

    if( (attr( key1 ) & FILE_DIRECTORY) != 0 && (attr( key2 ) & FILE_DIRECTORY) == 0 )
        return 1;
    if( (attr( key2 ) & FILE_DIRECTORY) != 0 && (attr( key1 ) & FILE_DIRECTORY) == 0 )
        return -1;

#ifdef __TV4ICC__
    return strcmpi( getName( key1 ), getName( key2 ) );
#else
    return stricmp( getName( key1 ), getName( key2 ) );
#endif
}

TStreamable *TFileCollection::build()
{
    return new TFileCollection( streamableInit );
}

void TFileCollection::writeItem( void *obj, opstream& os )
{
    TSearchRec *item = (TSearchRec *)obj;
#if 0
#if defined (__TV4OS2__) && !defined (__TV4BCC__)
    os << item->attr;
    os << item->date.year;
    os << item->date.month;
    os << item->date.day;
    os << item->time.hours;
    os << item->time.minutes;
    os << item->time.twosecs;
    os << item->size;
#else
    os << item->attr << item->time << item->size;
#endif
#endif
    os << item->attr;
    os << item->year;
    os << item->month;
    os << item->day;
    os << item->hours;
    os << item->minutes;
    os << item->seconds;
    os << item->size;

    os.writeString( item->name );
}

void *TFileCollection::readItem( ipstream& is )
{
    TSearchRec *item = new TSearchRec;
#if 0
#if defined (__TV4OS2__) && !defined (__TV4BCC__)
    is >> item->attr;
    long l;
    is >> l; item->date.year=l;
    is >> l; item->date.month=l;
    is >> l; item->date.day=l;
    is >> l; item->time.hours=l;
    is >> l; item->time.minutes=l;
    is >> l; item->time.twosecs=l;
    is >> item->size;
#else
    is >> item->attr >> item->time >> item->size;
#endif
#endif
    is >> item->attr;
    long l; // useless by now
    is >> l; item->year=l;
    is >> l; item->month=l;
    is >> l; item->day=l;
    is >> l; item->hours=l;
    is >> l; item->minutes=l;
    is >> l; item->seconds=l;
    is >> item->size;

    is.readString( item->name, sizeof(item->name) );
    return item;
}

