/*------------------------------------------------------------*/
/* filename -       tmouse.cpp                                */
/*                                                            */
/* function(s)                                                */
/*                  TMouse and THWMouse member functions      */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TEventQueue
#define Uses_TEvent
#define Uses_TScreen
#define Uses_TOS2Handles
#include <tv.h>

#ifdef __TV4EMX__
#include <sys/hw.h>
#include <dos.h>
#endif

#ifdef __TV4OS2__
#include <iostream.h> // debugging
#endif

#ifdef __TV4DJ__
#include <go32.h>
#include <dpmi.h>
_go32_dpmi_registers mouseIntRegs;
static _go32_dpmi_seginfo info;
static union REGS regs;
#endif

uchar THWMouse::buttonCount = 0;
Boolean THWMouse::handlerInstalled = False;
Boolean THWMouse:: noMouse= False; // !!! not used at all!?

THWMouse::THWMouse()
{
//    resume(); !!! This is done by TEventQueue
}

void THWMouse::resume()
{
//    cerr << "THWMouse::resume\n";
#ifdef __TV4TS__
    if( getvect( 0x33 ) == 0 )
        return;

    buttonCount=_ms_reset();
    if (buttonCount==INT_MAX) return;
    if (buttonCount==-1) buttonCount=2;
    _ms_setposition(0,0);
#endif

#ifdef __TV4WATCOMDOS__
    if( _dos_getvect( 0x33 ) == 0 )
        return;

    REGS inregs,outregs;

    inregs.w.ax=0; // Reset des Maustreibers
    int386( 0x33, &inregs, &outregs );
    buttonCount = outregs.w.bx;

    if (buttonCount==0x7FFF) return;
    if (buttonCount==-1) buttonCount=2;
    inregs.w.ax=4; // set mouse position
    inregs.w.cx=0;
    inregs.w.dx=0;
    int386( 0x33, &inregs, &outregs );
#endif

#ifdef __TV4OS2__
    EMX_SWITCH_1
    buttonCount = 2;
    USHORT bc;
    assert(! MouGetNumButtons ((PUSHORT) &bc, TOS2Handles::tiled->mouseHandle)  );
    buttonCount = bc;
    EMX_SWITCH_2
#endif
#ifdef __TV4EMX__
    // Get access to the mouse ringbuffer (DOS only)
    // This doesn't work if the emxmouse program isn't loaded
    // JS 1.12.94
    EMX_SWITCH_3
      cout << "Look for mouse handler..." << endl;
      buttonCount=0;
      unsigned long *p = (unsigned long*) ( ((char*) _memaccess( 0, 0xfff, 0)) + 0x11c );
      unsigned long p2 = *p;
      if (p2) {
        p2 = ((p2 & 0xFFFF0000) >> 12) + (p2 & 0x0000FFFF);
        char *p3 = (char*) _memaccess( p2 & 0xFFFFF000, (p2 | 0xFFF)+0x1000, 1);
        p3 += (p2 & 0x00000FFF);
        EMXPtr = (EMXSharedRec*) p3;
        if (EMXPtr->magic==3141592654) {
          cout << "emxmouse.exe found." << endl;
//          for (int i=1; i<20; i++) cout << "Yes!!!!!!!!!!!!!!!!" << endl;
          buttonCount=EMXPtr->buttonCount;
          EMXPtr->eventSemaphore=0;
        };
      };
      sleep(2);
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    regs.x.ax=0;
    regs.x.bx=0;
    regs.x.cx=0;
    regs.x.dx=0;
    int86(0x33,&regs,&regs);
    if( regs.x.ax != 0xffff )
    {
        return;
    }
    buttonCount=regs.x.bx;

    regs.x.ax=4;
    regs.x.bx=0;
    regs.x.cx=0;
    regs.x.dx=0;
    int86(0x33,&regs,&regs);
#endif
}

THWMouse::~THWMouse()
{
//    suspend(); !!! This is done by TEventQueue
}

void THWMouse::suspend()
{
//    cerr << "THWMouse::suspend\n";
    if( present() == False )
        return;
    hide();
    if( handlerInstalled == True )
        {
        registerHandler( 0, 0 );
        handlerInstalled = False;
        }
    buttonCount = 0;
}


void THWMouse::show()
{
#ifdef __TV4TS__
    _ms_cursor(_MS_SHOW);
#endif

#ifdef __TV4WATCOMDOS__
    REGS inregs,outregs;
    inregs.w.ax=1; // Show cursor
    int386( 0x33, &inregs, &outregs );
#endif

#ifdef __TV4OS2__
    EMX_SWITCH_1
    assert(! MouDrawPtr (TOS2Handles::tiled->mouseHandle)  );
    EMX_SWITCH_2
#endif

#ifdef __TV4EMX__
    EMX_SWITCH_3
    if (present()) {
      REGS r;
      r.x.ax=1;
      _int86(0x33,&r,&r);
    };
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    regs.x.ax=1;
    int86(0x33,&regs,&regs);
#endif

}

void THWMouse::hide()
{
#ifdef __TV4TS__
    _ms_cursor(_MS_HIDE);
#endif

#ifdef __TV4WATCOMDOS__
    REGS inregs,outregs;
    inregs.w.ax=2; // Hide cursor
    int386( 0x33, &inregs, &outregs );
#endif

#ifdef __TV4OS2__
    EMX_SWITCH_1
    NOPTRRECT *ptrArea = &TOS2Handles::tiled->ptrArea;
    ptrArea->row = ptrArea->col = 0;
    ptrArea->cRow = TScreen::screenHeight-1;
    ptrArea->cCol = TScreen::screenWidth-1;
    APIRET rc = MouRemovePtr (ptrArea, TOS2Handles::tiled->mouseHandle);
    if (rc) {
      cerr << rc << endl;
    };
    assert(!rc);
    EMX_SWITCH_2
#endif

#ifdef __TV4EMX__
    EMX_SWITCH_3
    if (present()) {
      REGS r;
      r.x.ax=2;
      _int86(0x33,&r,&r);
    }
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    regs.x.ax=2;
    int86(0x33,&regs,&regs);
#endif

}

void THWMouse::hide( const TRect& rect ) {
#ifdef __TV4TS__
  _ms_cursor(_MS_HIDE);
#endif

#ifdef __TV4WATCOMDOS__
    REGS inregs,outregs;
    inregs.w.ax=2; // Hide cursor
    int386( 0x33, &inregs, &outregs );
#endif

#ifdef __TV4OS2__
#ifdef __TV4EMX__
    if (_osmode == OS2_MODE) {
#endif
    NOPTRRECT *ptrArea = &TOS2Handles::tiled->ptrArea;
    ptrArea->row = rect.a.y;
    ptrArea->col = rect.a.x;
    ptrArea->cRow = rect.b.y-1;
    ptrArea->cCol = rect.b.x-1;
    APIRET rc=MouRemovePtr (ptrArea, TOS2Handles::tiled->mouseHandle);
    if (rc) {
      cerr << rect.a.y << ' ';
      cerr << rect.a.x << ' ';
      cerr << rect.b.y-1 << ' ';
      cerr << rect.b.x-1 << ' ';
      cerr << rc << endl;
    };
#ifdef __TV4EMX__
    };
#endif
#endif

#ifdef __TV4EMX__
    EMX_SWITCH_3
    if (present()) {
      REGS r;
      r.x.ax=2;
      _int86(0x33,&r,&r);
    };
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    regs.x.ax=2;
    int86(0x33,&regs,&regs);
#endif

};

void THWMouse::setRange( ushort rx, ushort ry )
{
// Useless under OS/2. The OS knows the screen resolution.

#ifdef __TV4TS__
  if( buttonCount != 0 )
      {
      _ms_range range;
      range.min_col=0;
      range.max_col=(rx<<3);
      range.min_row=0;
      range.max_row=(ry<<3);

      _ms_setrange( &range );
      }
#endif
#ifdef __TV4WATCOMDOS__
#if 0
// for some unknown reason, this crashes the VMM of DOS4GW.

  if( buttonCount != 0 )
      {

      REGS inregs,outregs;

      inregs.w.ax=7; // Horizontal
      inregs.w.cx=0;
      inregs.w.dx=(rx<<3);
      int386( 0x33, &inregs, &outregs );

      inregs.w.ax=8; // Horizontal
      inregs.w.cx=0;
      inregs.w.dx=(ry<<3);
      int386( 0x33, &inregs, &outregs );
      }
#endif
#endif

#ifdef __TV4EMX__
    EMX_SWITCH_3
    if (present()) {
      REGS r;
      r.x.ax=7;
      r.x.cx=0;
      r.x.dx=(rx<<3);
      _int86(0x33,&r,&r);
      r.x.ax=8;
      r.x.cx=0;
      r.x.dx=(ry<<3);
      _int86(0x33,&r,&r);
    };
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    if( buttonCount != 0 )
    {
       regs.x.ax=7;
       regs.x.cx=0;
       regs.x.dx=(rx<<3);
       int86(0x33,&regs,&regs);

       regs.x.ax=8;
       regs.x.cx=0;
       regs.x.dx=(ry<<3);
       int86(0x33,&regs,&regs);
    }
#endif

}

void THWMouse::getEvent( MouseEventType& me )
{
#ifdef __TV4TS__
    REGS r;
    r.x.ax=3;
    int86(0x33,&r,&r);
    me.buttons = r.h.bl;
    me.where.x = r.x.cx >> 3;
    me.where.y = r.x.dx >> 3;
    me.doubleClick = False;
#endif

#ifdef __TV4WATCOMDOS__
    REGS inregs,outregs;

    inregs.w.ax=3; // get state
    int386( 0x33, &inregs, &outregs );

    me.buttons = outregs.h.bl;
    me.where.x = outregs.w.cx >> 3;
    me.where.y = outregs.w.dx >> 3;
    me.doubleClick = False;
#endif

#if 0
    MOUEVENTINFO info;
    USHORT type = 0;
    MouReadEventQue(&info, &type, mou);
    me.buttons = ((info.fs & 6)  != 0) +
                 ((info.fs & 24) != 0) +
                 ((info.fs & 96) != 0);
    me.where.x = info.col;
    me.where.y = info.row;
    me.doubleClick = False;
#endif
#ifdef __TV4OS2__
    EMX_SWITCH_1
    me.buttons = 0;
    me.where.x = 0;
    me.where.y = 0;
    me.doubleClick = False;
    EMX_SWITCH_2
#endif
#ifdef __TV4EMX__
    EMX_SWITCH_3
    if (present()) {
      EMXPtr->curMouseSemaphore=1;
      me.buttons = EMXPtr->curMouse.buttons;
      me.where.x = EMXPtr->curMouse.x;
      me.where.y = EMXPtr->curMouse.y;
      me.doubleClick = False;
      EMXPtr->curMouseSemaphore=0;
    } else {
    };
    EMX_SWITCH_2
#endif
#ifdef __TV4DJ__
    regs.x.ax=3;
    regs.x.bx=0;
    regs.x.cx=0;
    regs.x.dx=0;
    int86(0x33,&regs,&regs);
    me.buttons = regs.x.bx;
    me.where.x = regs.x.cx >> 3;
    me.where.y = regs.x.dx >> 3;
    me.doubleClick = False;
#endif
}

#ifdef __TV4WATCOMDOS__
void THWMouse::registerHandler( unsigned mask, void _loadds (far *func)(int,int,int,int) )
#else
void THWMouse::registerHandler( unsigned mask, void (*func)() )
#endif
{
    if( !present() )
        return;

#ifdef __TV4TS__
  _ms_interrupt is;
  is.func=func;
  is.mask=mask;
  _ms_setinterrupt(&is);

  handlerInstalled = True;
#endif
#ifdef __TV4WATCOMDOS__

  REGS inregs,outregs;
  SREGS sregs;
  segread(&sregs);
  int (far *pointerToFarFunction)();
  unsigned int pointerToFlatFunction;
  extern void _loadds far globalMouseInt(int,int,int,int);
  
  // cout << "Init " << mask << endl;
  // Lock the mouse callback function
#if 1
  if (mask) {
    pointerToFlatFunction = (unsigned int) globalMouseInt;
    inregs.w.ax = 0x600;
    inregs.w.bx = pointerToFlatFunction >> 16;
    inregs.w.cx = pointerToFlatFunction & 0xFFFF;
    inregs.w.si = 0;
    inregs.w.si = 1000; // 1000 Bytes are enough
    int386x( 0x31, &inregs, &outregs, &sregs );
    if (outregs.w.cflag & 1) {
      cout << "lock failed" << endl;
    } else {
      cout << "lock good" << endl;
    }
  
    pointerToFlatFunction = (unsigned int) TEventQueue::mouseInt;
    inregs.w.ax = 0x600;
    inregs.w.bx = pointerToFlatFunction >> 16;
    inregs.w.cx = pointerToFlatFunction & 0xFFFF;
    inregs.w.si = 0;
    inregs.w.si = 2000; // 2000 Bytes are enough
    int386x( 0x31, &inregs, &outregs, &sregs );
    if (outregs.w.cflag & 1) {
      cout << "lock failed" << endl;
    } else {
      cout << "lock good" << endl;
    }

    pointerToFlatFunction = (unsigned int) &TEventQueue::eventQueue;
    inregs.w.ax = 0x600;
    inregs.w.bx = pointerToFlatFunction >> 16;
    inregs.w.cx = pointerToFlatFunction & 0xFFFF;
    inregs.w.si = 0;
    inregs.w.si = 2000; // 2000 Bytes are enough
    int386x( 0x31, &inregs, &outregs, &sregs );
    if (outregs.w.cflag & 1) {
      cout << "lock failed" << endl;
    } else {
      cout << "lock good" << endl;
    }

    for (int i=1; i<1000000; i++) ;
  } else {
    // no unlock, multiple lock are allowed
  }
#endif
  // Install the mouse callback function
  inregs.w.ax = 12; // install handler
  inregs.w.cx = mask;
  pointerToFarFunction= (int (far *)(void)) func;
  inregs.x.edx = FP_OFF( pointerToFarFunction );
  sregs.es     = FP_SEG( pointerToFarFunction );
  cout << inregs.x.edx << " " << sregs.es << endl;
  int386x( 0x33, &inregs, &outregs, &sregs );
  handlerInstalled = True;

#endif
#ifdef __TV4DJ__
  
  REGS inregs,outregs;
  SREGS sregs;
  __dpmi_regs dpmiRegs;
  __dpmi_meminfo memInfo;


    if( !present() )
        return;

    if (mask) {
      memInfo.address=(unsigned long) TEventQueue::mouseInt;
      memInfo.size=2000;
      if (__dpmi_lock_linear_region(&memInfo))
        cout << "lock good" << endl;
      else
        cout << "lock failed" << endl;

      memInfo.address=(unsigned long) &TEventQueue::eventQueue;
      memInfo.size=2000;
      if (__dpmi_lock_linear_region(&memInfo)) 
        cout << "lock good" << endl;
      else
        cout << "lock failed" << endl;

      // mouse callback
      info.pm_offset=(unsigned long)func;
      _go32_dpmi_allocate_real_mode_callback_retf(&info,&mouseIntRegs);
      dpmiRegs.x.ax = 12;
      dpmiRegs.x.cx = mask;
      dpmiRegs.x.dx = info.rm_offset;
      dpmiRegs.x.es = info.rm_segment;
      dpmiRegs.x.ss = 0;
      dpmiRegs.x.sp = 0;
      _go32_dpmi_simulate_int(0x33,&dpmiRegs);
      handlerInstalled = True;
    } else {
      // no unlocking.

      // If mask=0, the handler will never be called.
      dpmiRegs.x.ax = 12;
      dpmiRegs.x.cx = mask;
      dpmiRegs.x.dx = 0;
      dpmiRegs.x.es = 0;
      dpmiRegs.x.ss = 0;
      dpmiRegs.x.sp = 0;
      _go32_dpmi_simulate_int(0x33,&dpmiRegs);
      _go32_dpmi_free_real_mode_callback(&info);
      handlerInstalled = False;
    };
    return;
#endif

}

TMouse::TMouse()
{
//    show();
}

TMouse::~TMouse()
{
//    hide();
}

