/*------------------------------------------------------------*/
/* filename -       tscreen.cpp                               */
/*                                                            */
/* function(s)                                                */
/*                  TScreen member functions                  */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TScreen
#define Uses_TEvent
#define Uses_TOS2Handles
#include <tv.h>

#ifdef __TV4EMX__
#include <dos.h>
#include <sys/hw.h>
#include <sys/emx.h>
#endif

#ifdef __TV4TS__
#if !defined( __DOS_H )
#include <dos.h>
#endif  // __DOS_H

#ifdef PROTECT
ushort far * near TDisplay::equipment = (ushort far *)MK_FP( biosSeg, 0x10 );
uchar far * near TDisplay::crtInfo = (uchar far *)MK_FP( biosSeg, 0x87 );
uchar far * near TDisplay::crtRows = (uchar far *)MK_FP( biosSeg, 0x84 );
#else
ushort far * near TDisplay::equipment = (ushort far *)MK_FP( 0x40, 0x10 );
uchar far * near TDisplay::crtInfo = (uchar far *)MK_FP( 0x40, 0x87 );
uchar far * near TDisplay::crtRows = (uchar far *)MK_FP( 0x40, 0x84 );
#endif
#endif

ushort TScreen::startupMode = 0xFFFF;
ushort TScreen::startupCursor = 0;
ushort TScreen::screenMode = 0;
uchar TScreen::screenWidth = 0;
uchar TScreen::screenHeight = 0;
Boolean TScreen::hiResScreen = False;
Boolean TScreen::checkSnow = False;
uchar /*far*/ * TScreen::screenBuffer = 0;
ushort TScreen::cursorLines = 0;

#ifdef PROTECT

extern "C"
    extern char _protected;

#pragma warn -asc

/* This is some strange borland dpmi call. They run TV in protected mode. Grrrr.
   Maybe they just copied the Pascal version..
static ushort protGetRows(void)
{
#ifdef __TV4OS2__
  return 0;
#else
  REGS r;
  r.x.ax=0x1130;
  r.h.bh=0;
  r.h.dl=0; // What is this for?
  int86(0x10,&r,&r);
  if (r.h.dl==0) r.h.dl=24;
  return r.h.dl+1;
#endif
}
*/
#pragma warn .asc

#endif

ushort TDisplay::getCursorType()
{
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.ah=3;
  r.h.bh=0;
  int86(0x10,&r,&r);
  return r.x.cx;
#endif
#ifdef __TV4WATCOMDOS__
  REGS r;
  r.h.ah=3;
  r.h.bh=0;
  int386(0x10,&r,&r);
  return r.w.cx;
#endif
#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
#endif
#if defined(__TV4OS2__)
  VIOCURSORINFO &cinfo = TOS2Handles::tiled->cursorInfo;
  VioGetCurType(&cinfo,0);
  return ( cinfo.attr==0xFFFF ? 0x2000 : 0) + ((cinfo.yStart << 8) & 0x1F00) + cinfo.cEnd;
#endif
#ifdef __TV4EMX__
  }
#endif

  return 0;
}

void TDisplay::setCursorType( ushort ct )
{
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.ah=1;
  r.x.cx=ct;
  int86(0x10,&r,&r);
#endif
#ifdef __TV4WATCOMDOS__
  REGS r;
  r.h.ah=1;
  r.w.cx=ct;
  int386(0x10,&r,&r);
#endif

#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
#endif
#if defined(__TV4OS2__)
  VIOCURSORINFO &cinfo = TOS2Handles::tiled->cursorInfo;
  VioGetCurType(&cinfo,0);
  if ( ((ct>>8) & 0x60)  == 0x20 ) {
    cinfo.attr   = 0xFFFF;          // hide
  } else {
    cinfo.attr   = 0;               // show
    cinfo.yStart = uchar(ct>>8) & 0x1F;
    cinfo.cEnd   = uchar(ct);
    cinfo.cx     = 0;
  }
  VioSetCurType(&cinfo,0);

#endif
#ifdef __TV4EMX__
  }
#endif

}

void TDisplay::clearScreen( uchar w, uchar h )
{
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.bh=0x07;
  r.x.cx=0;
  r.h.dl=w;
  r.h.dh=h-1;
  r.x.ax=0x0600;
  int86(0x10,&r,&r);
#endif
#ifdef __TV4WATCOMDOS__
  REGS r;
  r.h.bh=0x07;
  r.w.cx=0;
  r.h.dl=w;
  r.h.dh=h-1;
  r.w.ax=0x0600;
  int386(0x10,&r,&r);
#endif

#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
#endif
#if defined(__TV4OS2__)
  unsigned short dummy=0x0070;
  assert(! VioScrollUp(0,0,-1,-1,100,(PBYTE) &dummy,0) );
#endif
#ifdef __TV4EMX__
  } else {
#if 0
    REGS r;
    r.h.ah=0x0F;
    r.h.bh=0x07;
    r.x.cx=0;
    r.h.dl=w;
    r.h.dh=h-1;
    r.x.ax=0x0600;
    _int86(0x10,&r,&r);
#endif
  };
#endif

}

ushort TDisplay::getRows()
{
#ifdef __TV4WATCOMDOS__
  REGS r;
  r.w.ax=0x1130;
  r.h.bh=0;
  r.h.dl=0; // What is this for?
  int386(0x10,&r,&r);
  if (r.h.dl==0) r.h.dl=24;
  return r.h.dl+1;
#endif
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.x.ax=0x1130;
  r.h.bh=0;
  r.h.dl=0; // What is this for?
  int86(0x10,&r,&r);
  if (r.h.dl==0) r.h.dl=24;
  return r.h.dl+1;
#endif

#ifdef __TV4EMX__
  int two[2];
  _scrsize (two);
  return two[1];
/*
  if (_osmode == OS2_MODE) {
    VIOMODEINFO &info = TOS2Handles::tiled->modeInfo;
    info.cb=sizeof(VIOMODEINFO);
    VioGetMode(&info,0);
    return info.row;
  } else {
    REGS r;
    r.x.ax=0x1130;
    r.h.bh=0;
    r.h.dl=0; // What is this for?
    _int86(0x10,&r,&r); // This won't work. VGA Bios calls are not supported by emx
    if (r.h.dl==0) r.h.dl=24;
    return r.h.dl+1;
  };
*/
#endif

#if defined(__TV4OS2__) && !defined(__TV4EMX__)
    VIOMODEINFO &info = TOS2Handles::tiled->modeInfo;
    info.cb=sizeof(VIOMODEINFO);
    VioGetMode(&info,0);
    return info.row;
#endif

}

ushort TDisplay::getCols()
{
#ifdef __TV4WATCOMDOS__
  REGS r;
  r.h.ah=0x0F;
  int386(0x10,&r,&r);
  return r.h.ah;
#endif
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.ah=0x0F;
  int86(0x10,&r,&r);
  return r.h.ah;
#endif
#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
    VIOMODEINFO &info = TOS2Handles::tiled->modeInfo;
    info.cb=sizeof(VIOMODEINFO);
    VioGetMode(&info,0);
    return info.col;
  } else {
    REGS r;
    r.h.ah=0x0F;
    _int86(0x10,&r,&r);
    return r.h.ah;
  };
#endif
#if defined(__TV4OS2__) && !defined(__TV4EMX__)
    VIOMODEINFO &info = TOS2Handles::tiled->modeInfo;
    info.cb=sizeof(VIOMODEINFO);
    APIRET rc = VioGetMode(&info,0);
//    cerr << "RC=" << rc << endl;
    return info.col;
#endif
}

ushort TDisplay::getCrtMode()
{
#ifdef __TV4OS2__
  ushort mode = smCO80;
#endif
#if defined(__TV4TS__) || defined(__TV4DJ__)
  REGS r;
  r.h.ah=0x0F;
  int86(0x10,&r,&r);
  ushort mode=r.h.al;
#endif
#ifdef __TV4WATCOMDOS__
  ushort mode = smCO80;
#endif
  if( getRows() > 25 )
      mode |= smFont8x8;
  return mode;

}

void TDisplay::setCrtMode( ushort mode )
{
#if 0
#if defined(__TV4TS__) || defined(__TV4DJ__)
    *equipment &= 0xFFCF;
    *equipment |= (mode == smMono) ? 0x30 : 0x20;
    *crtInfo &= 0x00FE;

   
      REGS r;
      r.h.ah=0;
      r.h.al=mode;
      int86(0x10,&r,&r);


    if( (mode & smFont8x8) != 0 )
        {
	  r.x.ax=0x1112;        // 8x8 Font (43/50 Zeilen)
	  r.h.bl=0;
	  int86(0x10,&r,&r);

        if( getRows() > 25 )
            {
            *crtInfo |= 1;

	      r.h.ah = 1;		// Cursorform
	      r.x.cx = 0x0607;
	      int86(0x10,&r,&r);
	      r.h.ah = 0x12;    	// Hardcopy anpassen
	      r.h.bl = 0x20;
	      int86(0x10,&r,&r);
            }
        }
#endif
#endif
}

TScreen::TScreen()
{
//    cerr << "TScreen::TScreen\n";
//    startupMode = getCrtMode();
//    startupCursor = getCursorType();
//    setCrtData();
}

void TScreen::resume()
{
//    cerr << "TScreen::resume\n";
    startupMode = getCrtMode();
    startupCursor = getCursorType();
//    if (screenMode != startupMode)
//       setCrtMode( screenMode );
    setCrtData();
}

TScreen::~TScreen()
{
//    suspend();
}

void TScreen::suspend()
{
//    cerr << "TScreen::suspend\n";
    if( startupMode != screenMode )
        setCrtMode( startupMode );
    clearScreen();
    setCursorType( startupCursor );
}

ushort TScreen::fixCrtMode( ushort mode )
{
#ifdef __TV4TS__
    _AX = mode;
    if( _AL != smMono && _AL != smCO80 && _AL != smBW80 )
        _AL = smCO80;
    return _AX;
#else
  return mode;
#endif
}

void TScreen::setCrtData()
{
    screenMode = getCrtMode();
    screenWidth = getCols();
    screenHeight = getRows();
    hiResScreen = Boolean(screenHeight > 25);

    if( screenMode == smMono )
        {
#ifdef __TV4TS__
        screenBuffer = (uchar far *)MK_FP( 0xB000, 0 );
#else
        screenBuffer = (uchar*) 0; // no monochrome on OS/2
                                   // or with DOS-Extenders.
                                   // Sorry.
#endif
        checkSnow = False;
        }
    else
        {

#ifdef __TV4TS__
    screenBuffer = (uchar far *)MK_FP( 0xB800, 0 );
#endif
#if defined(__TV4ICC__) || defined (__TV4BCC__) || defined(__TV4WATCOMOS2__)
#ifdef __TV4BCC__
    uchar _far16 *s;
#endif
#ifdef __TV4ICC__
    uchar * _Seg16 s; // Congrats IBM! _Seg16 at the right position
#endif
#ifdef __TV4WATCOMOS2__
    uchar * _Seg16 s;
#endif
    ushort l;
    VioGetBuf( (PULONG) &s, &l, 0 ); // !!! OS/2 specific
    screenBuffer = s; // Automatic conversion
#endif
#ifdef __TV4EMX__
  if (_osmode == OS2_MODE) {
    _far16ptr s;
    ushort l;
    VioGetBuf( (PULONG) &s, &l, 0 ); // !!! OS/2 specific
    screenBuffer = (uchar*) _emx_16to32(s); // Selfmade Conversion.
  } else {
    unsigned addr, end_addr;
          addr = 0xb8000;
          end_addr = (addr + screenHeight * screenWidth * 2 - 1) | 0xfff;
          screenBuffer = (uchar*) _memaccess (addr, end_addr, 1);
  };
#endif
#ifdef __TV4WATCOMDOS__
    screenBuffer = ( uchar * ) 0xB8000; // I really like that one. js
#endif
#ifdef __TV4DJ__
    screenBuffer = ( uchar * ) 0xFEDC1234; // TView::writeView checks for this value.
//    screenBuffer = ( uchar * ) &ScreenPrimary; // Doesn't work.
#endif

    }
    checkSnow = False;
    cursorLines = getCursorType();
    setCursorType( 0x2000 );

}

void TScreen::clearScreen()
{
    TDisplay::clearScreen( screenWidth, screenHeight );
}

void TScreen::setVideoMode( ushort mode )
{
    setCrtMode( fixCrtMode( mode ) );
    setCrtData();
}
