/*------------------------------------------------------------*/
/* filename -       tvtext2.cpp                               */
/*                                                            */
/*------------------------------------------------------------*/

/*------------------------------------------------------------*/
/*                                                            */
/*    Turbo Vision -  Version 1.0                             */
/*                                                            */
/*                                                            */
/*    Copyright (c) 1991 by Borland International             */
/*    All Rights Reserved.                                    */
/*                                                            */
/*------------------------------------------------------------*/

#define Uses_TEditWindow
#define Uses_TFileList
#define Uses_TProgram
#define Uses_MsgBox
#define Uses_TChDirDialog
#define Uses_TFileDialog
#define Uses_TFileInfoPane
#define Uses_TSystemError
#define Uses_TDeskTop
#define Uses_TKeys
#include <tv.h>

#if !defined( __CTYPE_H )
#include <ctype.h>
#endif  // __CTYPE_H

#ifdef __TV_ENG__
static const char altCodes1[] =
    "QWERTYUIOP\0\0\0\0ASDFGHJKL\0\0\0\0\0ZXCVBNM";
static const char altCodes2[] = "1234567890-=";
#endif
#ifdef __TV_GER__
static const char altCodes1[] =
    "QWERTZUIOP\0\0\0\0ASDFGHJKL\0\0\0\0\0YXCVBNM";
static const char altCodes2[] = "1234567890=?";
#endif

char getAltChar(ushort keyCode)
{
    if ((keyCode & 0xff) == 0)
        {
        ushort tmp = (keyCode >> 8);

        if( tmp == (kbAltSpace>>8) ) // as suggested by Ilfak
            return '\xF0';      // special case to handle alt-Space

        else if( tmp >= 0x10 && tmp <= 0x32 )
            return altCodes1[tmp-0x10];     // alt-letter

        else if( tmp >= 0x78 && tmp <= 0x83 )
            return altCodes2[tmp - 0x78];   // alt-number

        }
    return 0;
}

ushort getAltCode(char c)
{
    if( c == 0 )
        return 0;

    c = toupper(c);

    if( (unsigned char)c == 0xF0 )
        return kbAltSpace;       // special case to handle alt-Space

    for( int i = 0; i < sizeof( altCodes1 ); i++)
       if( altCodes1[i] == c )
        return (i+0x10) << 8;

    for( i = 0; i < sizeof( altCodes2); i++)
        if (altCodes2[i] == c)
            return (i+0x78) << 8;

    return 0;
}

#ifdef __TV_ENG__
const char * TEditWindow::clipboardTitle = "Clipboard";
const char * TEditWindow::untitled = "Untitled";

const char * TFileList::tooManyFiles = "Too many files.";

const char * TProgram::exitText = "~Alt-X~ Exit";

const char * MsgBoxText::yesText = "~Y~es";
const char * MsgBoxText::noText = "~N~o";
const char * MsgBoxText::okText = "O~K~";
const char * MsgBoxText::cancelText = "~C~ancel";
const char * MsgBoxText::warningText = "Warning";
const char * MsgBoxText::errorText = "Error";
const char * MsgBoxText::informationText = "Information";
const char * MsgBoxText::confirmText = "Confirm";

const char * TChDirDialog::changeDirTitle = "Change Directory";
const char * TChDirDialog::dirNameText = "Directory ~n~ame";
const char * TChDirDialog::dirTreeText = "Directory ~t~ree";
const char * TChDirDialog::okText = "O~K~";
const char * TChDirDialog::chdirText = "~C~hdir";
const char * TChDirDialog::revertText = "~R~evert";
const char * TChDirDialog::helpText = "Help";
const char * TChDirDialog::drivesText = "Drives";
const char * TChDirDialog::invalidText = "Invalid directory";

const char * TFileDialog::filesText = "~F~iles";
const char * TFileDialog::openText = "~O~pen";
const char * TFileDialog::okText = "O~K~";
const char * TFileDialog::replaceText = "~R~eplace";
const char * TFileDialog::clearText = "~C~lear";
const char * TFileDialog::cancelText = "Cancel";
const char * TFileDialog::helpText = "~H~elp";
const char * TFileDialog::invalidDriveText = "Invalid drive or directory";
const char * TFileDialog::invalidFileText = "Invalid file name.";

const char * TFileInfoPane::pmText = "p";
const char * TFileInfoPane::amText = "a";


// !!! annoying gcc bug
const char * const months1[] =
    {
    "","Jan","Feb","Mar","Apr","May","Jun",
    "Jul","Aug","Sep","Oct","Nov","Dec"
    };
const char * const *TFileInfoPane::months = months1;

//const char *const *TSystemError::errorString1 = 0;

const char * const errorString1[16] =
{
//    "Critical disk error on drive %c",
    "Disk is write-protected in drive %c",
    "Unknown unit %c",
    "Disk is not ready in drive %c",
    "Critical Error (unknown command) on drive %c",
    "Data integrity error on drive %c",
    "Critical error (bad request) on drive %c",
    "Seek error on drive %c",
    "Unknown media type in drive %c",
    "Sector not found on drive %c",
    "Printer out of paper",
    "Write fault on drive %c",
    "Read fault on drive %c",
    "Hardware failure on drive %c",
    "Bad memory image of FAT detected",
    "Device access error",
    "Insert diskette in drive %c"
};
const char * const *TSystemError::errorString=errorString1;


const char * TSystemError::sRetryOrCancel = "~Enter~ Retry  ~Esc~ Cancel";

const char TDeskTop::defaultBkgrnd = '\xB0';
#endif

#ifdef __TV_GER__
const char * TEditWindow::clipboardTitle = "Clipboard";
const char * TEditWindow::untitled = "OhneNamen";

const char * TFileList::tooManyFiles = "Zu viele Dateien.";

const char * TProgram::exitText = "~Alt-X~ Ende";

const char * MsgBoxText::yesText = "~J~a";
const char * MsgBoxText::noText = "~N~ein";
const char * MsgBoxText::okText = "O~K~";
const char * MsgBoxText::cancelText = "~A~bbruch";
const char * MsgBoxText::warningText = "Warnung";
const char * MsgBoxText::errorText = "Fehler";
const char * MsgBoxText::informationText = "Information";
const char * MsgBoxText::confirmText = "Besttigung";

const char * TChDirDialog::changeDirTitle = "Anderes Verzeichnis";
const char * TChDirDialog::dirNameText = "Verzeichnis~n~ame";
const char * TChDirDialog::dirTreeText = "Verzeichnis~b~aum";
const char * TChDirDialog::okText = "O~K~";
const char * TChDirDialog::chdirText = "~C~hdir";
const char * TChDirDialog::revertText = "~R~evert";
const char * TChDirDialog::helpText = "Hilfe";
const char * TChDirDialog::drivesText = "Laufwerke";
const char * TChDirDialog::invalidText = "Ungltiges Verzeichnis";

const char * TFileDialog::filesText = "~D~ateien";
const char * TFileDialog::openText = "~~ffnen";
const char * TFileDialog::okText = "O~K~";
const char * TFileDialog::replaceText = "~E~rsetzen";
const char * TFileDialog::clearText = "~L~schen";
const char * TFileDialog::cancelText = "Abbruch";
const char * TFileDialog::helpText = "~H~ilfe";
const char * TFileDialog::invalidDriveText = "Ungltiger Pfad";
const char * TFileDialog::invalidFileText = "Ungltiger Dateiname.";

const char * TFileInfoPane::pmText = "p";
const char * TFileInfoPane::amText = "a";


// !!! annoying gcc bug
const char * const months1[] =
    {
    "","Jan","Feb","Mr","Apr","Mai","Jun",
    "Jul","Aug","Sep","Okt","Nov","Dez"
    };
const char * const *TFileInfoPane::months = months1;

//const char *const *TSystemError::errorString1 = 0;

const char * const errorString1[16] =
{
    "Diskette in Laufwerk c% ist schreibgeschtzt",
    "Zugriff auf unbekanntes Gert %c",
    "Laufwerk c% is nicht bereit",
    "Unbekannter Befehl an Laufwerk %c",
    "Prfsummenfehler beim Lesen von Laufwerk %c",
    "Falsche Datenlnge beim Zugriff auf Laufwerk %c",
    "Suchfehler auf Laufwerk %c",
    "Unbekannter Datentrger in Laufwerk %c",
    "Sektor nicht gefunden auf Laufwerk %c",
    "Der Drucker hat kein Papier mehr",
    "Schreibfehler auf Laufwerk %c",
    "Lesefehler auf Laufwerk %c",
    "Hardwarefehler auf Laufwerk %c",
    "Die FAT ist beschdigt",
    "Gertefehler",
    "Legen Sie eine Diskette in Laufwerk %c ein"

};
const char * const *TSystemError::errorString=errorString1;


const char * TSystemError::sRetryOrCancel = "~Enter~ Wiederholen  ~Esc~ Abbruch";

const char TDeskTop::defaultBkgrnd = '\xB0';
#endif

